using System;
using MonoTouch.UIKit;
using MonoTouch.Foundation;

namespace ScanBarCodes
{
	public class Book : NSObject
	{
		#region ctor

		public Book (string isbn)
		{
			this.ISBN = isbn;
		}

		[Export("initWithCoder:")]
		public Book (NSCoder coder)
		{
			NSString isbn = (NSString)coder.DecodeObject (@"isbn");
			if (isbn != null)
				this.ISBN = isbn.ToString ();
		}

		#endregion // ctor

		#region properties
		[Export(@"ISBN")]
		public string ISBN {
			get;
			set;
		}

		[Export("Title")]
		public string Title {
			get;
			set;
		}

		[Export("CoverImage")]
		public UIImage Cover
		{
			get
			{
				UIImage img = Utilities.RetrieveImage (this.ISBN);
				if (img == null) 
				{
				}
				return img;
			}
		}


		#endregion // properties

		#region overrides
		public override void EncodeTo (NSCoder coder)
		{
			if (this.ISBN != null)
				coder.Encode( new NSString (this.ISBN), @"isbn");
		
		}
		#endregion // overrides
	}
}

