using System;
using MonoTouch.Foundation;
using MonoTouch.UIKit;

namespace ScanBarCodes
{
	public static class Utilities
	{
		public static NSString pathToDataFile(string key)
		{
			string[] paths =   NSSearchPath.GetDirectories(NSSearchPathDirectory.LibraryDirectory,NSSearchPathDomain.User, true);
			string rootPath = paths[0];
			NSString rootPathAsNSString = new NSString (rootPath);
			rootPathAsNSString = rootPathAsNSString.AppendPathComponent (new NSString("LibraryAppDataStorage"));
			Utilities.ensureDiretory(rootPathAsNSString.ToString());
			rootPathAsNSString = rootPathAsNSString.AppendPathComponent (new NSString(key));
			rootPathAsNSString = rootPathAsNSString.AppendPathExtension (new NSString("data"));
			return rootPathAsNSString;
		}

		public static UIImage RetrieveImage(string imageName)
		{
			string[] paths =   NSSearchPath.GetDirectories(NSSearchPathDirectory.LibraryDirectory,NSSearchPathDomain.User, true);
			string rootPath = paths[0];
			NSString rootPathAsNSString = new NSString (rootPath);
			rootPathAsNSString = rootPathAsNSString.AppendPathComponent (new NSString("LibraryAppDataStorage"));
			rootPathAsNSString = rootPathAsNSString.AppendPathComponent (new NSString("Images"));
			Utilities.ensureDiretory(rootPathAsNSString.ToString());

			rootPathAsNSString = rootPathAsNSString.AppendPathComponent (new NSString(imageName));
			rootPathAsNSString = rootPathAsNSString.AppendPathExtension (new NSString("png"));

			NSFileManager manager = NSFileManager.DefaultManager;
			UIImage img = null;
			if (manager.FileExists (rootPathAsNSString.ToString ())) {
				 img = new UIImage (rootPathAsNSString.ToString ());
			}

			return img;
		}

		public static void SaveImage(UIImage img, string isbn)
		{
			string[] paths =   NSSearchPath.GetDirectories(NSSearchPathDirectory.LibraryDirectory,NSSearchPathDomain.User, true);
			string rootPath = paths[0];
			NSString rootPathAsNSString = new NSString (rootPath);
			rootPathAsNSString = rootPathAsNSString.AppendPathComponent (new NSString("LibraryAppDataStorage"));
			rootPathAsNSString = rootPathAsNSString.AppendPathComponent (new NSString("Images"));
			Utilities.ensureDiretory(rootPathAsNSString.ToString());

			rootPathAsNSString = rootPathAsNSString.AppendPathComponent (new NSString(isbn));
			rootPathAsNSString = rootPathAsNSString.AppendPathExtension (new NSString("png"));


			NSFileManager manager = NSFileManager.DefaultManager;
			if (!manager.FileExists (rootPathAsNSString.ToString ())) {
				NSDictionary d = null;
				manager.CreateFile (rootPathAsNSString.ToString (), img.AsPNG(), d);
			}
		}

		static void ensureDiretory(string path)
		{
			NSFileManager manager = NSFileManager.DefaultManager;
			if(! manager.FileExists(path))
			{
				manager.CreateDirectory (path, true, null);
			}
		}
	}
}

